
// VideoConverterDlg.h :  
//

#pragma once


#include "Redirect.h"
#include "XRichEditCtrl.h"

// CVideoConverterDlg ȭ 
class CVideoConverterDlg : public CDialog, public CRedirect
{
// Դϴ.
public:
	enum { MODE_CBR, MODE_VBR, MODE_PASS_1, MODE_PASS_2 };	// ڵ 

	CVideoConverterDlg(DWORD idd, CWnd* pParent);	// ǥ Դϴ.

// ȭ  Դϴ.
	//enum { IDD = IDD_VIDEOCONVERTER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV Դϴ.

private :
	BOOL			OpenFile(CString sSrcFileName);
	void			Message(LPCTSTR szMsg, ...);
	void			MessageLn(LPCTSTR szMsg, ...);
	void			EnableDisableControl();
	void			LoadSettings();
	void			SaveSettings();
	void			InitOption();
	void			SettingToScreen();
	void			ScreenToSetting();

	CString			GetEncoderCmdline(int nEncodingMode);

private :
	XRichEditCtrl	m_messageCtrl;
	BOOL			m_bConverting;
	int				m_nEncodingMode;			// CBR, 1PASS, 2PASS

private :			// 
	CString			m_sDestPath;				// 
	CString			m_sVideoCodec;				//  ڵ
	BOOL			m_bVideoVBR;				// VBR ڵ
	BOOL			m_bChangeVideoSize;
	BOOL			m_bChangeVideoFps;
	int				m_nVideoBitrate;
	int				m_nVideoQscale;
	int				m_nVideoFps;
	int				m_nVideoGop;
	int				m_nAudioBitrate;
	int				m_nAudioSamplerate;
	CString			m_sVideoSize;
	CString			m_sAudioChannel;
	CString			m_sFileName;
	BOOL			m_bNoAudio;
	BOOL			m_bBitrateFilename;
	BOOL			m_bEncryption;
	BOOL			m_b2PassEncoding;

private :
	int				m_nOriginalVidW;
	int				m_nOriginalVidH;


public :	// CRedirect 
	virtual void OnChildStarted(LPCTSTR lpszCmdLine);
	virtual void OnChildStdOutWrite(LPCSTR lpszOutput);
	virtual void OnChildStdErrWrite(LPCSTR lpszOutput);
	virtual void OnChildTerminate();



// Դϴ.
protected:
	HICON m_hIcon;

	//  ޽  Լ
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedButtonFindSrcfile();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnBnClickedBtnStart();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedBtnStop();
	afx_msg void OnBnClickedChkVideoChangeSize();
	afx_msg void OnBnClickedChkVideoChangeFps();
	afx_msg void OnBnClickedChkNoAudio();
	afx_msg void OnBnClickedButtonInit();
	afx_msg void OnBnClickedButtonOpenDstpath();
	afx_msg void OnBnClickedButtonFindDstpath();
	afx_msg void OnBnClickedBtnAbout();
	afx_msg void OnBnClickedChkFilenameBitrate();
	afx_msg void OnBnClickedChkEncryption();
	afx_msg void OnBnClickedChk2Pass();
	afx_msg void OnBnClickedChkVBR();
};
